//+------------------------------------------------------------------+
//|                                                      Program.mqh |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#include <EasyAndFastGUI\Controls\WndEvents.mqh>
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
class CProgram : public CWndEvents
  {
protected:
   //--- 
   CWindow           m_window;
   //---  
   CCanvasTable      m_canvas_table;
   //---
public:
                     CProgram();
                    ~CProgram();
   //---  
   void              OnEvent(const int milliseconds);
   //---   
   bool              CreateInfoPanel(void);
   //---
protected:
   //---  
   bool              CreateWindow(const string text);
   //---  
#define TABLE_GAP_X             (1)
#define TABLE_GAP_Y             (19)
   bool              CreateCanvasTable(void);
  };
//+------------------------------------------------------------------+
//| Constructor                                                      |
//+------------------------------------------------------------------+
CProgram::CProgram(void)
  {
  }
//+------------------------------------------------------------------+
//| Destructor                                                       |
//+------------------------------------------------------------------+
CProgram::~CProgram(void)
  {
  }
//+------------------------------------------------------------------+
//|                                                           |
//+------------------------------------------------------------------+
void CProgram::OnEvent(const int milliseconds)
  {
   static int count =0;  // 
   string     str   =""; //   
//---     
   switch(count)
     {
      case 0 : str="SCRIPT PANEL";     break;
      case 1 : str="SCRIPT PANEL .";   break;
      case 2 : str="SCRIPT PANEL ..";  break;
      case 3 : str="SCRIPT PANEL ..."; break;
     }
//---   
   m_window.CaptionText(str);
//---      
   for(int r=0; r<13; r++)
      m_canvas_table.SetValue(1,r,string(::rand()));
//---    
   m_canvas_table.DrawTable();
//---  
   m_chart.Redraw();
//---  
   count++;
//---   , 
   if(count>3)
      count=0;
//--- 
   ::Sleep(milliseconds);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
bool CProgram::CreateInfoPanel(void)
  {
//---  
   if(!CreateWindow("SCRIPT PANEL"))
      return(false);
//---   
   if(!CreateCanvasTable())
      return(false);
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+
bool CProgram::CreateWindow(const string caption_text)
  {
//---      
   CWndContainer::AddWindow(m_window);
//--- 
   int x=2;
   int y=14;
//--- 
   m_window.Movable(false);
   m_window.XSize(207);
   m_window.YSize(244);
   m_window.WindowBgColor(clrWhiteSmoke);
   m_window.WindowBorderColor(clrLightSteelBlue);
   m_window.CaptionBgColor(clrLightSteelBlue);
   m_window.CaptionBgColorHover(clrLightSteelBlue);
//---       
   if(!m_window.CreateWindow(m_chart_id,m_subwin,caption_text,x,y))
      return(false);
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
bool CProgram::CreateCanvasTable(void)
  {
#define COLUMNS_TOTAL 2
#define ROWS_TOTAL    13
//---   
   m_canvas_table.WindowPointer(m_window);
//--- 
   int x=m_window.X()+TABLE_GAP_X;
   int y=m_window.Y()+TABLE_GAP_Y;
//---   
   int visible_rows_total=13;
//---        
   int width[]={120,84};
   ENUM_ALIGN_MODE align[]={ALIGN_RIGHT,ALIGN_LEFT};
//---    
   m_canvas_table.XSize(205);
   m_canvas_table.TableSize(COLUMNS_TOTAL,ROWS_TOTAL);
   m_canvas_table.VisibleTableSize(0,visible_rows_total);
   m_canvas_table.TextAlign(align);
   m_canvas_table.ColumnsWidth(width);
   m_canvas_table.GridColor(clrLightGray);
//---   
   for(int c=0; c<COLUMNS_TOTAL; c++)
      for(int r=0; r<ROWS_TOTAL; r++)
         m_canvas_table.SetValue(c,r,(c==0)? "Parameter "+string(r)+":" : string(::rand()));
//---   
   if(!m_canvas_table.CreateTable(m_chart_id,m_subwin,x,y))
      return(false);
//---       
   CWndContainer::AddToElementsArray(0,m_canvas_table);
   return(true);
  }
//+------------------------------------------------------------------+
